package gamejam.usc.bossoverload;


import android.graphics.Point;
import android.os.Bundle;
import android.util.Log;
import android.view.Display;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnTouchListener;
import android.widget.Button;
import android.widget.RelativeLayout;
import android.widget.TextView;

import gamejam.usc.bossoverload.angle2d.AngleActivity;
import gamejam.usc.bossoverload.angle2d.AngleVector;
import gamejam.usc.bossoverload.angle2d.AngleSprite;
//import gamejam.usc.bossoverload.angle2d.FPSCounter;
import gamejam.usc.bossoverload.angle2d.AngleSpriteLayout;
import gamejam.usc.bossoverload.angle2d.AngleRotatingSprite;
import gamejam.usc.bossoverload.angle2d.AngleUI;

public class MainBossActivity extends AngleActivity {

	public static final float rotSpeed = 0.0f;
	public int screenWidth;
	public int screenHeight;
	public AngleVector startShot;
	//private AngleObject ogField;
	private int count = 0;
	private int bulletLimit;
	float startX = 0;
	float diffX = 0;
	AngleVector target;
	float playerX, playerY, changedPlayerX;
	float playerSpeed = 100;
	boolean flagBossBlink = false;
	float bossAlpha = 0.9f;
	int counter = 0;
	int bossHealth = 15;
	TextView tv;
	boolean flagWin = false;
	
	public class MainClass extends AngleUI{
	
		final Sprite mLogoBossReal;
		final Sprite mLogoBoss;
		Sprite mLogo;		
		
		public MainClass(AngleActivity activity){
			
			super(activity);
			//initialization
			count = 0;
			bulletLimit = 10;
			Display display = getWindowManager().getDefaultDisplay();
			Point size = new Point();
			display.getSize(size);
			screenWidth = size.x;
			screenHeight = size.y;
			
			// YOU
			AngleSpriteLayout mLogoLayout = new AngleSpriteLayout(mGLSurfaceView, 72, 72, R.drawable.ic_launcher);
			mLogo = new Sprite(mLogoLayout, 0.0f, "P");
			// player position
			//mLogo.mPosition.set(400, 1100);
			mGLSurfaceView.addObject(mLogo);
			// till here
			
			// BOSS thru looking glass
			AngleSpriteLayout mLogoLayoutBossReal = new AngleSpriteLayout(mGLSurfaceView, 72, 72, R.drawable.spot);
			mLogoBossReal = new Sprite(mLogoLayoutBossReal, 0.0f, "BR");
			AngleVector avReal = new AngleVector(5,5);
			mLogoBossReal.mScale = avReal;
			mLogoBossReal.alpha = 0.0f;
			mGLSurfaceView.addObject(mLogoBossReal);
			
			// BOSS
			AngleSpriteLayout mLogoLayoutBoss = new AngleSpriteLayout(mGLSurfaceView, 72, 72, R.drawable.ic_launcher);
			mLogoBoss = new Sprite(mLogoLayoutBoss, 0.9f, "B");
			AngleVector av = new AngleVector(5,5);
			mLogoBoss.mScale = av;
			mGLSurfaceView.addObject(mLogoBoss);
			// till here			
		}
		
		public class Sprite extends AngleRotatingSprite{
			
			float alpha;
			float alphaDir;
			String charType;			
			float speed;
			
			public Sprite(AngleSpriteLayout spriteLayout, float a, String charType){
				
				super(spriteLayout);
				alphaDir = a;
				alpha = a;
				this.charType = charType;
				if(charType.compareTo("B") == 0){
					mPosition.set(400, 250);
					flagBossBlink = false;
					alphaDir = bossAlpha;
					alpha = bossAlpha;
				} else if(charType.compareTo("BR") == 0){
					mPosition.set(400, 250);
					mAlpha = 0.0f;
				} else if(charType.compareTo("P") == 0){
					speed = playerSpeed;
					playerX = 400;
					mPosition.set(400, 1000);
					target = new AngleVector(mPosition);
				}
			}
			
			private void createBullet(){
				AngleSpriteLayout mBossShot = new AngleSpriteLayout(mGLSurfaceView, 72, 72, R.drawable.ic_launcher);
				AngleVector av = new AngleVector(400, 250);
				BossShoot shot = new BossShoot(av, mBossShot);
				AngleVector avShot = new AngleVector(0.5f,0.5f);
				shot.mScale = avShot;
				mGLSurfaceView.addObject(shot);
				//bullets[count] = shot;
				count++;
			}
			
			@Override
			public void step(float dt){
				//mRotation += dt*rotSpeed;
				
				if(charType.compareTo("B") == 0){
					/*try
					{
						Thread.sleep(70);
					} catch (InterruptedException e)
					{
						e.printStackTrace();
					}
					createBullet();*/	
					
					if(flagBossBlink)
					{
						mAlpha += dt*alphaDir;
						if(mAlpha > 1)
						{
							mAlpha = 1;
							alphaDir = -alpha;
							counter++;
						}
						else if(mAlpha < 0)
						{
							mAlpha = 0;
							alphaDir = alpha;
						}
						if(counter > 2){
							flagBossBlink = false;
							counter = 0;
							//mAlpha = 1;
						}
					}
				}
				else if(charType.compareTo("P") == 0)
				{
					mAlpha += dt*alphaDir;
					if(mAlpha > 1)
					{
						mAlpha = 1;
						alphaDir = -alpha;
					}
					else if(mAlpha < 0)
					{
						mAlpha = 0;
						alphaDir = alpha;
					}
					
					if(mPosition.mX > screenWidth - 70){
						target.mX = mPosition.mX = screenWidth - 72;
					}
					if(mPosition.mX < 70){
						target.mX = mPosition.mX = 72;
					}
					if((int)mPosition.mX>(int)target.mX){
						mPosition.mX += speed*dt;
					} 
					if((int)mPosition.mX<(int)target.mX){
						mPosition.mX -= speed*dt;
					}
					if((int)mPosition.mY<(int)target.mY){
						mPosition.mY += speed*dt;
					}
					if((int)mPosition.mY>(int)target.mY){
						mPosition.mY -= speed*dt;
					}
					changedPlayerX = mPosition.mX;
					playerY = mPosition.mY;
				}
				
				super.step(dt);
			}
		}
		
		public class BossShoot extends AngleSprite{
			
			public BossShoot(AngleVector boss, AngleSpriteLayout layout){
				super(layout);
				mPosition.set(boss.mX, boss.mY + 150);
				//startShot = boss.mY + 150;
			}
			
			@Override
			public void step(float secondsElapsed){
				
				mPosition.mY += 300 * secondsElapsed;
				if(mPosition.mY > screenHeight){
					//if(count > bulletLimit){
						//bullets[1].mDie = true;
						//count--;
						mDie = true;
					//}
					//else{
						//mPosition.mY = startShot;
					//}
				}
				super.step(secondsElapsed);
			}
		}
		
		/*@Override
		public boolean onTouchEvent(MotionEvent event) {
			
			if(event.getAction() == MotionEvent.ACTION_DOWN){
				Log.d("Touch", "HHHHHHHHHHHHHHHHHHHHHHHHHHHH");
			}
			Log.d("Touch", "AAAAAAAAAAAAAAAAAAAa");
			System.out.print("ALOHA");
			mLogo.target.set(event.getX(), event.getY());
			return true;
		}*/
	}
	
	public class PlayerShoot extends AngleSprite{
		
		public PlayerShoot(AngleVector boss, AngleSpriteLayout layout){
			super(layout);
			mPosition.set(changedPlayerX, 1000);
			startShot = new AngleVector(changedPlayerX, playerY);
		}
		
		@Override
		public void step(float secondsElapsed){
			
			mPosition.mY -= 300 * secondsElapsed;
			if(mPosition.mY < 0){
				/*if(count > bulletLimit){
					//bullets[1].mDie = true;
					count--;
					mDie = true;
				}
				else{*/
					//mPosition.mY = startShot.mY - 36;
					mDie = true;
					//mPosition.mX = startShot.mX;
				//}
			}
			if((mPosition.mX > 350 && mPosition.mX < 450) && (mPosition.mY > 200 && mPosition.mY < 300)){
				mDie = true;
				count++;
				flagBossBlink = true;
			}
			super.step(secondsElapsed);
		}
	}
	
	private void makePlayerBullet(){
		AngleSpriteLayout mShot = new AngleSpriteLayout(mGLSurfaceView, 72, 72, R.drawable.ic_launcher);
		AngleVector av = new AngleVector(400, 250);
		PlayerShoot shot = new PlayerShoot(av, mShot);
		AngleVector avShot = new AngleVector(0.5f,0.5f);
		shot.mScale = avShot;
		mGLSurfaceView.addObject(shot);
	}
	
	private void killBoss(MainClass mainClass){
		mainClass.mLogoBoss.alpha = 0;
		mainClass.mLogoBossReal.alpha = 0;
		flagBossBlink = false;
		tv.setVisibility(TextView.VISIBLE);
	}
	
	@Override
	public void onCreate(Bundle savedInstanceState){
		super.onCreate(savedInstanceState);
		
		final MainClass mainClass = new MainClass(this);
		
		Button btnLookingGlass = new Button(this);
		btnLookingGlass.setText("Looking glass                  ");
		btnLookingGlass.setOnTouchListener(new OnTouchListener(){
		
			@Override
			public boolean onTouch(View v, MotionEvent e) {
				if(e.getAction() == MotionEvent.ACTION_DOWN){
					mainClass.mLogoBoss.mAlpha = 0.60f;
					mainClass.mLogoBossReal.mAlpha = 1.0f;
				} else if(e.getAction() == MotionEvent.ACTION_UP){
					mainClass.mLogoBoss.mAlpha = 1.0f;
					mainClass.mLogoBossReal.mAlpha = 0.0f;
				}
				return false;
			}
		});

		Button btnMovement = new Button(this);
		btnMovement.setText("                      Move!!!                       ");
		btnMovement.setOnTouchListener(new OnTouchListener(){

			@Override
			public boolean onTouch(View v, MotionEvent event) {
				
				if(event.getAction() == MotionEvent.ACTION_DOWN){
					startX = event.getX();
				}
				if(event.getAction() == MotionEvent.ACTION_MOVE){
					if(startX != 0){
						diffX = startX - event.getX();
						target.mX = diffX * 10;
					} else {
						target.mX = playerX;
					}
				}
				if(event.getAction() == MotionEvent.ACTION_UP){
					target.mX = 0;
					startX = 0;
					target.mX = playerX;
				}
				return false;
			}
			
		});
		
		Button btnShoot = new Button(this);
		btnShoot.setText("Shoot!");
		btnShoot.setOnTouchListener(new OnTouchListener(){
		
			@Override
			public boolean onTouch(View v, MotionEvent e) {
				if(e.getAction() == MotionEvent.ACTION_DOWN){// || e.getAction() == MotionEvent.ACTION_MOVE){
					
					if(count > bossHealth){						
						killBoss(mainClass);
						//count = 0;
					} else {
						makePlayerBullet();
					}
				} else if(e.getAction() == MotionEvent.ACTION_UP){
					
				}
				return false;
			}
		});
		
		tv = new TextView(this);
		tv.setText("                                             YOU WIN!!");
		tv.setVisibility(TextView.INVISIBLE);
		tv.setGravity(1);
		
		RelativeLayout mMainLayout = new RelativeLayout(this);	
		mMainLayout.addView(this.mGLSurfaceView);
		
		RelativeLayout.LayoutParams lp = new RelativeLayout.LayoutParams(RelativeLayout.LayoutParams.WRAP_CONTENT, 
																					RelativeLayout.LayoutParams.WRAP_CONTENT);
		lp.setMargins(0, 0, 0, 0);
		
		lp.addRule(RelativeLayout.ALIGN_PARENT_RIGHT);
		lp.addRule(RelativeLayout.ALIGN_PARENT_BOTTOM);
		btnLookingGlass.setLayoutParams(lp);
		mMainLayout.addView(btnLookingGlass);
		
		RelativeLayout.LayoutParams lpm = new RelativeLayout.LayoutParams(RelativeLayout.LayoutParams.WRAP_CONTENT, 
																					RelativeLayout.LayoutParams.WRAP_CONTENT);
		lpm.setMargins(0, 0, 0, 0);
		lpm.addRule(RelativeLayout.ALIGN_PARENT_BOTTOM);
		btnMovement.setLayoutParams(lpm);
		mMainLayout.addView(btnMovement);
		
		RelativeLayout.LayoutParams relativeLayoutParameters = new RelativeLayout.LayoutParams(RelativeLayout.LayoutParams.MATCH_PARENT, 
																					RelativeLayout.LayoutParams.MATCH_PARENT);
		
		RelativeLayout.LayoutParams lpb = new RelativeLayout.LayoutParams(RelativeLayout.LayoutParams.WRAP_CONTENT, 
																					RelativeLayout.LayoutParams.WRAP_CONTENT);
		lpb.setMargins(0, 0, 0, 0);
		
		lpb.addRule(RelativeLayout.ALIGN_PARENT_RIGHT);
		lpb.addRule(RelativeLayout.ALIGN_PARENT_BOTTOM);
		btnShoot.setLayoutParams(lpb);
		mMainLayout.addView(btnShoot);
		
		//RelativeLayout.LayoutParams lp = new RelativeLayout.LayoutParams(RelativeLayout.LayoutParams.WRAP_CONTENT, 
																					//RelativeLayout.LayoutParams.WRAP_CONTENT);
		//lp.setMargins(0, 0, 0, 0);
		
		//btnLookingGlass.setLayoutParams(lp);
		mMainLayout.addView(tv);
		
		setContentView(mMainLayout, relativeLayoutParameters);
	}
}
